## ros-melodic-mongodb-store 0.5.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(mongodb_store)

# for ROS indigo compile without c++11 support
if(DEFINED ENV{ROS_DISTRO})
  if(NOT $ENV{ROS_DISTRO} STREQUAL "indigo")
    add_compile_options(-std=c++11)
    message(STATUS "Building with C++11 support")
  else()
    message(STATUS "ROS Indigo: building without C++11 support")
  endif()
else()
  message(STATUS "Environmental variable ROS_DISTRO not defined, checking OS version")
  file(STRINGS /etc/os-release RELEASE_CODENAME
		REGEX "VERSION_CODENAME=")
  if(NOT ${RELEASE_CODENAME} MATCHES "trusty")
    add_compile_options(-std=c++11)
    message(STATUS "OS distro is not trusty: building with C++11 support")
  else()
    message(STATUS "Ubuntu Trusty: building without C++11 support")
  endif()
endif()

find_package(catkin REQUIRED COMPONENTS roscpp message_generation rospy std_msgs std_srvs mongodb_store_msgs topic_tools)

set(CMAKE_MODULE_PATH   ${PROJECT_SOURCE_DIR}/cmake)
find_package(MongoClient REQUIRED)

## Uncomment this if the package has a setup.py. This macro ensures
## modules and global scripts declared therein get installed
## See http://ros.org/doc/api/catkin/html/user_guide/setup_dot_py.html

catkin_python_setup()

#######################################
## Declare ROS messages and services ##
#######################################


## Generate services in the 'srv' folder
add_service_files(
  FILES
  GetParam.srv
  SetParam.srv
  MongoFind.srv
  MongoUpdate.srv
  MongoInsert.srv
)


## Generate added messages and services with any dependencies listed here
generate_messages(
  DEPENDENCIES
  std_msgs
)

###################################
## catkin specific configuration ##
###################################
## The catkin_package macro generates cmake config files for your package
## Declare things to be passed to dependent projects
## INCLUDE_DIRS: uncomment this if you package contains header files
## LIBRARIES: libraries you create in this project that dependent projects also need
## CATKIN_DEPENDS: catkin_packages dependent projects also need
## DEPENDS: system dependencies of this project that dependent projects also need


catkin_package(
 INCLUDE_DIRS include
 LIBRARIES message_store ${MongoClient_INCLUDE_DIR}
 CATKIN_DEPENDS mongodb_store_msgs topic_tools
 DEPENDS MongoClient
)

###########
## Build ##
###########

## Specify additional locations of header files
## Your package locations should be listed before other locations
include_directories(
  include
  ${catkin_INCLUDE_DIRS}
  ${MongoClient_INCLUDE_DIR} 
)

link_directories(${catkin_LINK_DIRS})
link_directories(${MongoClient_LINK_DIRS})

add_library(message_store src/message_store.cpp )

add_executable(example_mongodb_store_cpp_client src/example_mongodb_store_cpp_client.cpp)
add_executable(example_multi_event_log src/example_multi_event_log.cpp)
# add_executable(pc_test src/point_cloud_test.cpp)


add_dependencies(example_mongodb_store_cpp_client mongodb_store_msgs_generate_messages_cpp )
add_dependencies(message_store mongodb_store_msgs_generate_messages_cpp )

target_link_libraries(message_store
  ${MongoClient_LIBRARIES}
  ${catkin_LIBRARIES}
)



# Specify libraries to link a library or executable target against
target_link_libraries(example_mongodb_store_cpp_client
  message_store
  ${MongoClient_LIBRARIES}  
  ${catkin_LIBRARIES}  
)

target_link_libraries(example_multi_event_log
  message_store
  ${MongoClient_LIBRARIES}  
  ${catkin_LIBRARIES}  
)

target_link_libraries(example_multi_event_log
  message_store
  ${MongoClient_LIBRARIES}  
  ${catkin_LIBRARIES}  
)


#############
## Install ##
#############

# all install targets should use catkin DESTINATION variables
# See http://ros.org/doc/api/catkin/html/adv_user_guide/variables.html

## Mark executable scripts (Python etc.) for installation
## in contrast to setup.py, you can choose the destination
install(DIRECTORY scripts/
        DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
        USE_SOURCE_PERMISSIONS)

# Mark other files for installation (e.g. launch and bag files, etc.)
install(
  DIRECTORY launch
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
)

# Mark cpp header files for installation
install(DIRECTORY include/mongodb_store/
  DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
)

## Mark executables and/or libraries for installation
install(TARGETS example_mongodb_store_cpp_client example_multi_event_log message_store #pc_test
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)


#############
## Testing ##
#############

if (CATKIN_ENABLE_TESTING)
  find_package(catkin REQUIRED COMPONENTS rostest)

  add_rostest(tests/message_store.test)
  add_rostest(tests/config_manager.test)
  add_rostest(tests/replication.test)

  add_executable(message_store_cpp_test tests/message_store_cpp_test.cpp)

  target_link_libraries(message_store_cpp_test
    message_store
    ${OPENSSL_LIBRARIES}
    ${catkin_LIBRARIES}
    ${Boost_LIBRARIES}
    gtest
  )

  add_rostest(tests/message_store_cpp_client.test)

endif()

=== debian/changelog ===
ros-melodic-mongodb-store (0.5.2-1stretch) stretch; urgency=high

  * added python-future to package.xml, which got lost in previous commit for some reasons ...
  * corrected typo
  * removed flags for most of files for simplicity, also included future.utils, may introduce undesireable dependency though
  * resolved python2 backward compatibility issues
    not thouroughly checked though
    Added python version checks, where needed.
    Changes not adjusted to version:
    - print always with brackets
    - excepti XXX, e ==> except XXX as e
    as there is no problem with python2 to best of my knowledge
  * adjusted python funtions for python3
  * add dependency to package xml
  * back to system mongo
  * Contributors: Ferenc Balint-Benczedi, Nick Hawes, Shingo Kitagawa, Volker Gabler, vgab

 -- Nick Hawes <nickh@robots.ox.ac.uk>  Mon, 11 Nov 2019 00:00:00 -0000

ros-melodic-mongodb-store (0.5.1-1stretch) stretch; urgency=high

  * added python-future to package.xml
  * removed flags for most of files for simplicity, also included future.utils, may introduce undesireable dependency though
  * resolved python2 backward compatibility issues
    not thouroughly checked though
    Added python version checks, where needed.
    Changes not adjusted to version:
    - print always with brackets
    - excepti XXX, e ==> except XXX as e
    as there is no problem with python2 to best of my knowledge
  * adjusted python funtions for python3
  * Contributors: Shingo Kitagawa, Volker Gabler

 -- Nick Hawes <nickh@robots.ox.ac.uk>  Fri, 28 Jun 2019 00:00:00 -0000

ros-melodic-mongodb-store (0.5.0-1stretch) stretch; urgency=high

  * Merge pull request #231 <https://github.com/strands-project/mongodb_store/issues/231> from bbferka/melodic-devel
    Melodic devel
  * add dependency to package xml
  * make it run
  * back to system mongo
  * Contributors: Ferenc Balint-Benczedi, Nick Hawes

 -- Nick Hawes <nickh@robots.ox.ac.uk>  Thu, 20 Dec 2018 00:00:00 -0000

ros-melodic-mongodb-store (0.4.5-1stretch) stretch; urgency=high

  * Allow to bind mongod to host
    The existing solution bind the mongod server to all interfaces. This
    exposes the server to the outside. This could be a potensial security
    issue if someone has access to your network. This change allows you
    to only bind the server to the host specified by the
    mongodb_host parameter. The solution was created with a flag
    defaulting to false to prevent this from being a breaking change.
    Specifying the argument bind_to_host will add a bind argument to the
    executable:
    ```
    [..., "--bind_ip", self._mongo_host]
    ```
    Info: The bind_ip argument [supports hostnames, ipaddresses
    and socket
    paths](https://docs.mongodb.com/manual/reference/program/mongod/#cmdoption-mongod-bind-ip)
    so using localhost or 127.0.0.1 is valid for binding to
    localhost only. To bind to all interfaces use 0.0.0.0.
  * adds service to reset all local overrides.
    Exposes a new service /config_manager/reset_params std_srvs/Trigger
    that will reset all local overrides their default value. This provides
    a ROS compatible way of getting back to the default values.
  * Contributors: Jørgen Borgesen, Nick Hawes, Marc Hanheide

 -- Nick Hawes <nickh@robots.ox.ac.uk>  Fri, 28 Jun 2019 00:00:00 -0000

ros-melodic-mongodb-store (0.4.3-1stretch) stretch; urgency=high

  * Merge pull request #243 <https://github.com/strands-project/mongodb_store/issues/243> from furushchev/get-publisher
    add method to get num subscribers for insertion
  * Merge pull request #242 <https://github.com/strands-project/mongodb_store/issues/242> from furushchev/shutdown
    shutdown publisher on destruction
  * Merge pull request #241 <https://github.com/strands-project/mongodb_store/issues/241> from furushchev/add-published-at
    append _meta.published_at for stamped messages
  * Merge pull request #240 <https://github.com/strands-project/mongodb_store/issues/240> from furushchev/fix-replicate
    display more info on replication
  * add method to get num subscribers for insertion
  * shutdown publisher on destruction
  * append _meta.published_at for stamped messages
  * display more info on replication
  * Merge pull request #234 <https://github.com/strands-project/mongodb_store/issues/234> from jorgenfb/fix/prevent-null-values
    Make sure None / null values reaches the parameter server
  * Make sure None / null values reaches the parameter server
  * Contributors: Jørgen Borgesen, Nick Hawes, Yuki Furuta

 -- Nick Hawes <nickh@robots.ox.ac.uk>  Thu, 04 Apr 2019 00:00:00 -0000

ros-melodic-mongodb-store (0.4.2-1stretch) stretch; urgency=high

  * instead of lsb-release read /etc/os-version from CMake to find OS version
  * Contributors: Ferenc Balint-Benczedi

 -- Nick Hawes <nickh@robots.ox.ac.uk>  Mon, 04 Jun 2018 00:00:00 -0000

ros-melodic-mongodb-store (0.4.1-1stretch) stretch; urgency=high

  * check if env. var. exists if not decide based on OS version
  * Contributors: Ferenc Balint-Benczedi

 -- Nick Hawes <nickh@robots.ox.ac.uk>  Tue, 29 May 2018 00:00:00 -0000

ros-melodic-mongodb-store (0.4.0-1stretch) stretch; urgency=high

  * if compiler supports it use C++11
  * Contributors: Ferenc Balint-Benczedi

 -- Nick Hawes <nickh@robots.ox.ac.uk>  Wed, 23 May 2018 00:00:00 -0000

ros-melodic-mongodb-store (0.3.8-1stretch) stretch; urgency=high

  * Merge pull request #220 <https://github.com/strands-project/mongodb_store/issues/220> from furushchev/replication-with-query
    Replication with query
  * mongodb_store: support filter by query on moving entries
  * Merge pull request #218 <https://github.com/strands-project/mongodb_store/issues/218> from furushchev/test-replicator
    Test replication functionality
  * mongodb_store: avoid to use rosrun in test code
  * mongodb_store: test replication
  * mongodb_server: minor bugfix


=== debian/control ===
Source: ros-melodic-mongodb-store
Section: misc
Priority: extra
Maintainer: Nick Hawes <nickh@robots.ox.ac.uk>
Build-Depends: debhelper (>= 9.0.0), libmongoclient-dev, libssl-dev, mongodb, python-catkin-pkg, ros-melodic-catkin, ros-melodic-geometry-msgs, ros-melodic-message-generation, ros-melodic-mongodb-store-msgs, ros-melodic-roscpp, ros-melodic-rospy, ros-melodic-rostest, ros-melodic-std-msgs, ros-melodic-std-srvs, ros-melodic-topic-tools
Homepage: http://www.ros.org/wiki/mongodb_store
Standards-Version: 3.9.2

Package: ros-melodic-mongodb-store
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libmongoclient-dev, mongodb, python-future, python-pymongo, ros-melodic-geometry-msgs, ros-melodic-mongodb-store-msgs, ros-melodic-roscpp, ros-melodic-rospy, ros-melodic-std-msgs, ros-melodic-std-srvs, ros-melodic-topic-tools
Description: A package to support MongoDB-based storage and analysis for data from a ROS system, eg.
 saved messages, configurations etc

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/melodic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/melodic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/melodic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-melodic-mongodb-store//opt/ros/melodic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_install
